gtksourceviewmm: Gsv::Buffer Class Reference

gtksourceviewmm 3.2.0

- Main Page
- Related Pages
- Modules
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions
Gsv::Buffer Class Reference

Buffer object for View. More...

`#include <gtksourceviewmm/buffer.h>`

Inheritance diagram for Gsv::Buffer:
[legend]

List of all members.

## Public Member Functions
GtkSourceBuffer* | gobj ()
| Provides access to the underlying C GObject.
const GtkSourceBuffer* | gobj () const
| Provides access to the underlying C GObject.
GtkSourceBuffer* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | get_highlight_matching_brackets () const
| Determines whether bracket match highlighting is activated for the source buffer.
void | set_highlight_matching_brackets (bool highlight=true)
| Controls the bracket match highlighting function in the buffer.
bool | get_highlight_syntax () const
| Determines whether syntax highlighting is activated in the source buffer.
void | set_highlight_syntax (bool highlight=true)
| Controls whether syntax is highlighted in the buffer.
int | get_max_undo_levels () const
| Determines the number of undo levels the buffer will track for buffer edits.
void | set_max_undo_levels (int max_undo_levels)
| Sets the number of undo levels for user actions the buffer will track.
Glib::RefPtr< Language > | get_language ()
| Returns the Language associated with the buffer.
Glib::RefPtr< const Language > | get_language () const
| Returns the Language associated with the buffer.
void | set_language (const Glib::RefPtr< Language >& language)
| Associate a Language with the source buffer.
bool | can_undo () const
| Determines whether a source buffer can undo the last action.
bool | can_redo () const
| Determines whether a source buffer can redo the last action (i.e. if the last operation was an undo).
void | undo ()
| Undoes the last user action which modified the buffer.
void | redo ()
| Redoes the last undo operation.
void | begin_not_undoable_action ()
| Marks the beginning of a not undoable action on the buffer, disabling the undo manager.
void | end_not_undoable_action ()
| Marks the end of a not undoable action on the buffer.
bool | backward_iter_to_source_mark (Gtk::TextIter& iter, const Glib::ustring& category)
| Moves iter to the position of the previous Mark of the given category.
bool | backward_iter_to_source_mark (Gtk::TextIter& iter)
| Moves iter to the position of the previous Mark of any category.
bool | forward_iter_to_source_mark (Gtk::TextIter& iter, const Glib::ustring& category)
| Moves iter to the position of the next Mark of the given category.
bool | forward_iter_to_source_mark (Gtk::TextIter& iter)
| Moves iter to the position of the next Mark of the given category.
void | ensure_highlight (const Gtk::TextIter&start, const Gtk::TextIter&end)
| Forces buffer to analyze and highlight the given area synchronously.
Glib::RefPtr< StyleScheme > | get_style_scheme ()
| Returns the StyleScheme currently used in buffer.
Glib::RefPtr< const StyleScheme > | get_style_scheme () const
| Returns the StyleScheme currently used in buffer.
void | set_style_scheme (const Glib::RefPtr< StyleScheme >& scheme)
| Sets style scheme used by the buffer.
void | unset_style_scheme ()
| Unsets style scheme used by the buffer.
Glib::RefPtr< Gsv::Mark > | create_source_mark (const Glib::ustring& name, const Glib::ustring& category, const Gtk::TextIter& where)
| Creates a source mark in the buffer of category category.
Glib::RefPtr< Gsv::Mark > | create_source_mark (const Glib::ustring& category, const Gtk::TextIter& where)
| Creates an anonymous source mark in the buffer of category category.
std::vector< Glib::RefPtr < Gsv::Mark > > | get_source_marks_at_line (int line, const Glib::ustring& category) const
| Returns the list of marks of the given category at line.
std::vector< Glib::RefPtr < Gsv::Mark > > | get_source_marks_at_line (int line) const
| Returns the list of marks of any category at line.
std::vector< Glib::RefPtr < Gsv::Mark > > | get_source_marks_at_iter (Gtk::TextIter& iter, const Glib::ustring& category) const
| Returns the list of marks of the given category at iter.
std::vector< Glib::RefPtr < Gsv::Mark > > | get_source_marks_at_iter (Gtk::TextIter& iter) const
| Returns the list of marks of any category at iter.
void | remove_source_marks (const Gtk::TextIter&start, const Gtk::TextIter&end, const Glib::ustring& category)
| Remove all marks of category between start and end from the buffer.
void | remove_source_marks (const Gtk::TextIter&start, const Gtk::TextIter&end)
| Remove all marks of any category between start and end from the buffer.
bool | iter_has_context_class (const Gtk::TextIter& iter, const Glib::ustring& context_class) const
| Check if the class context_class is set on `iter`.
bool | iter_backward_to_context_class_toggle (Gtk::TextIter& iter, const Glib::ustring& context_class) const
| Moves backward to the next toggle (on or off) of the context class.
bool | iter_forward_to_context_class_toggle (Gtk::TextIter& iter, const Glib::ustring& context_class) const
| Moves forward to the next toggle (on or off) of the context class.
std::vector< Glib::ustring > | get_context_classes_at_iter (const Gtk::TextIter& iter) const
| Get all defined context classes at iter.
Glib::RefPtr< UndoManager > | get_undo_manager ()
| Get the undo manager associated with the buffer.
Glib::RefPtr< const UndoManager > | get_undo_manager () const
| Get the undo manager associated with the buffer.
void | set_undo_manager (const Glib::RefPtr< const UndoManager >& undo_manager)
| Set the buffer undo manager.
void | set_default_undo_manager ()
| Set the default buffer undo manager.
Glib::PropertyProxy< bool > | property_highlight_syntax ()
| Whether to highlight syntax in the buffer.
Glib::PropertyProxy_ReadOnly < bool > | property_highlight_syntax () const
| Whether to highlight syntax in the buffer.
Glib::PropertyProxy< bool > | property_highlight_matching_brackets ()
| Whether to highlight matching brackets.
Glib::PropertyProxy_ReadOnly < bool > | property_highlight_matching_brackets () const
| Whether to highlight matching brackets.
Glib::PropertyProxy< int > | property_max_undo_levels ()
| Number of undo levels for the buffer.
Glib::PropertyProxy_ReadOnly< int > | property_max_undo_levels () const
| Number of undo levels for the buffer.
Glib::PropertyProxy < Glib::RefPtr< Language > > | property_language ()
| Language object to get highlighting patterns from.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Language > > | property_language () const
| Language object to get highlighting patterns from.
Glib::PropertyProxy_ReadOnly < bool > | property_can_undo () const
| Whether Undo operation is possible.
Glib::PropertyProxy_ReadOnly < bool > | property_can_redo () const
| Whether Redo operation is possible.
Glib::PropertyProxy < Glib::RefPtr< StyleScheme > > | property_style_scheme ()
| Style scheme.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< StyleScheme > > | property_style_scheme () const
| Style scheme.
Glib::PropertyProxy < Glib::RefPtr< UndoManager > > | property_undo_manager ()
| The buffer undo manager.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< UndoManager > > | property_undo_manager () const
| The buffer undo manager.
Glib::SignalProxy2< void, Gtk::TextIter&, Gtk::TextIter& > | signal_highlight_updated ()
| Emitted whenever the syntax highlighting information has been updated, so that views can request a redraw if the region changed is visible.
Glib::SignalProxy1< void, const Glib::RefPtr < Gtk::TextMark >& > | signal_source_mark_updated ()
| Emitted whenever a marker of sourcebuffer has changed and needs to be redisplayed by the view.
Glib::SignalProxy0< void > | signal_undo ()
| Emitted whenever undo is requested.
Glib::SignalProxy0< void > | signal_redo ()
| Emitted whenever redo is requested.
Glib::SignalProxy2< void, Gtk::TextIter &, BracketMatchType > | signal_bracket_matched ()
| Sets iter to a valid iterator pointing to the matching bracket if state is BracketMatchType::BRACKET_MATCH_FOUND.
## Static Public Member Functions
static Glib::RefPtr< Buffer > | create ()
| Create a new source buffer.
static Glib::RefPtr< Buffer > | create (const Glib::RefPtr< Gtk::TextTagTable >& tag_table)
| Create a new source buffer.
static Glib::RefPtr< Buffer > | create (const Glib::RefPtr< Language >& language)
| Creates a new source buffer using the highlighting patterns in language.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gsv::Buffer > | wrap (GtkSourceBuffer* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Buffer object for View.

The Buffer class is the model for View widgets. It extends the Gtk::TextBuffer class by adding features useful to display and edit source code as syntax highlighting and bracket matching. It also implements support for undo/redo operations.

To create a Buffer use Buffer::create(). A convenience overload for initial setting a Language is also provided.

By default highlighting is enabled, but you can disable it with Buffer::set_highlight_syntax().

## Member Function Documentation

bool Gsv::Buffer::backward_iter_to_source_mark | ( | Gtk::TextIter & | iter,
|  | const Glib::ustring & | category
| ) |  |

Moves iter to the position of the previous Mark of the given category.

Parameters:

  iter | An iterator.
  category | Category to search.

Returns:
  `true` if iter was moved.

bool Gsv::Buffer::backward_iter_to_source_mark | ( | Gtk::TextIter & | iter | ) |

Moves iter to the position of the previous Mark of any category.

Parameters:

  iter | An iterator.

Returns:
  `true` if iter was moved.

void Gsv::Buffer::begin_not_undoable_action | ( |  | ) |

Marks the beginning of a not undoable action on the buffer, disabling the undo manager.

Typically you would call this function before initially setting the contents of the buffer (e.g. when loading a file in a text editor).

You may nest begin_not_undoable_action() / end_not_undoable_action() blocks.

bool Gsv::Buffer::can_redo | ( |  | ) | const

Determines whether a source buffer can redo the last action (i.e. if the last operation was an undo).

Returns:
  `true` if a redo is possible.

bool Gsv::Buffer::can_undo | ( |  | ) | const

Determines whether a source buffer can undo the last action.

Returns:
  `true` if it's possible to undo the last action.

static Glib::RefPtr<Buffer> Gsv::Buffer::create | ( |  | ) | `[static]`

Create a new source buffer.

Internally it will create a new Gtk::TextTagTable also.

Returns:
  A new Buffer.

Since gtksourceviewmm 2.10:

Reimplemented from Gtk::TextBuffer.

static Glib::RefPtr<Buffer> Gsv::Buffer::create | ( | const Glib::RefPtr< Gtk::TextTagTable > & | tag_table | ) | `[static]`

Create a new source buffer.

Parameters:

  tag_table | A Gtk::TextTagTable or empty Glib::RefPtr, to create new.

Returns:
  A new Buffer.

Reimplemented from Gtk::TextBuffer.

static Glib::RefPtr<Buffer> Gsv::Buffer::create | ( | const Glib::RefPtr< Language >& | language | ) | `[static]`

Creates a new source buffer using the highlighting patterns in language.

Parameters:

  language | A Language.

Returns:
  A new Buffer

Glib::RefPtr<Gsv::Mark> Gsv::Buffer::create_source_mark | ( | const Glib::ustring & | category,
|  | const Gtk::TextIter & | where
| ) |  |

Creates an anonymous source mark in the buffer of category category.

A source mark is a Gtk::TextMark but organised into categories. Depending on the category a pixbuf can be specified that will be displayed along the line of the mark.

Like a Gtk::TextMark, a Mark can be anonymous.

Marks always have left gravity and are moved to the beginning of the line when the user deletes the line they were in.

Typical uses for a source mark are bookmarks, breakpoints, current executing instruction indication in a source file, etc.

Parameters:

  category | A string defining the mark category.
  where | Location to place the mark.

Returns:
  A new Mark.

Since gtksourceviewmm 2.10:

Glib::RefPtr<Gsv::Mark> Gsv::Buffer::create_source_mark | ( | const Glib::ustring & | name,
|  | const Glib::ustring & | category,
|  | const Gtk::TextIter & | where
| ) |  |

Creates a source mark in the buffer of category category.

A source mark is a Gtk::TextMark but organised into categories. Depending on the category a pixbuf can be specified that will be displayed along the line of the mark.

Marks always have left gravity and are moved to the beginning of the line when the user deletes the line they were in.

Typical uses for a source mark are bookmarks, breakpoints, current executing instruction indication in a source file, etc.

Parameters:

  name | The name of the mark.
  category | A string defining the mark category.
  where | Location to place the mark.

Returns:
  A new Mark.

void Gsv::Buffer::end_not_undoable_action | ( |  | ) |

Marks the end of a not undoable action on the buffer.

When the last not undoable block is closed through the call to this function, the list of undo actions is cleared and the undo manager is re-enabled.

void Gsv::Buffer::ensure_highlight | ( | const Gtk::TextIter & | start,
|  | const Gtk::TextIter & | end
| ) |  |

Forces buffer to analyze and highlight the given area synchronously.

Note:
  This is a potentially slow operation and should be used only when you need to make sure that some text not currently visible is highlighted, for instance before printing.

Parameters:

  start | Start of the area to highlight.
  end | End of the area to highlight.

bool Gsv::Buffer::forward_iter_to_source_mark | ( | Gtk::TextIter & | iter | ) |

Moves iter to the position of the next Mark of the given category.

Parameters:

  iter | An iterator.

Returns:
  `true` if iter was moved.

bool Gsv::Buffer::forward_iter_to_source_mark | ( | Gtk::TextIter & | iter,
|  | const Glib::ustring & | category
| ) |  |

Moves iter to the position of the next Mark of the given category.

Parameters:

  iter | An iterator.
  category | Category to search.

Returns:
  `true` if iter was moved.

std::vector<Glib::ustring> Gsv::Buffer::get_context_classes_at_iter | ( | const Gtk::TextIter & | iter | ) | const

Get all defined context classes at iter.

Parameters:

  iter | A Gtk::TextIter.

Returns:
  An array of context class names.

Since gtksourceviewmm 2.10:

bool Gsv::Buffer::get_highlight_matching_brackets | ( |  | ) | const

Determines whether bracket match highlighting is activated for the source buffer.

Returns:
  `true` if the source buffer will highlight matching brackets.

bool Gsv::Buffer::get_highlight_syntax | ( |  | ) | const

Determines whether syntax highlighting is activated in the source buffer.

Returns:
  `true` if syntax highlighting is enabled, `false` otherwise.

Glib::RefPtr<Language> Gsv::Buffer::get_language | ( |  | ) |

Returns the Language associated with the buffer.

Returns:
  A Language associated with the buffer, or empty Glib::RefPtr.

Glib::RefPtr<const Language> Gsv::Buffer::get_language | ( |  | ) | const

Returns the Language associated with the buffer.

Returns:
  A Language associated with the buffer, or empty Glib::RefPtr.

int Gsv::Buffer::get_max_undo_levels | ( |  | ) | const

Determines the number of undo levels the buffer will track for buffer edits.

Returns:
  The maximum number of possible undo levels or -1 if no limit is set.

std::vector<Glib::RefPtr<Gsv::Mark> > Gsv::Buffer::get_source_marks_at_iter | ( | Gtk::TextIter & | iter,
|  | const Glib::ustring & | category
| ) |  | const

Returns the list of marks of the given category at iter.

Parameters:

  iter | An iterator.
  category | Category to search for.

Returns:
  A list of source marks.

std::vector<Glib::RefPtr<Gsv::Mark> > Gsv::Buffer::get_source_marks_at_iter | ( | Gtk::TextIter & | iter | ) | const

Returns the list of marks of any category at iter.

Parameters:

  iter | An iterator.

Returns:
  A list of source marks.

std::vector<Glib::RefPtr<Gsv::Mark> > Gsv::Buffer::get_source_marks_at_line | ( | int | line,
|  | const Glib::ustring & | category
| ) |  | const

Returns the list of marks of the given category at line.

Parameters:

  line | A line number.
  category | Category to search for.

Returns:
  A list of source marks.

std::vector<Glib::RefPtr<Gsv::Mark> > Gsv::Buffer::get_source_marks_at_line | ( | int | line | ) | const

Returns the list of marks of any category at line.

Parameters:

  line | A line number.

Returns:
  A list of source marks.

Glib::RefPtr<StyleScheme> Gsv::Buffer::get_style_scheme | ( |  | ) |

Returns the StyleScheme currently used in buffer.

Returns:
  The StyleScheme set by set_style_scheme(), or empty Glib::RefPtr.

Glib::RefPtr<const StyleScheme> Gsv::Buffer::get_style_scheme | ( |  | ) | const

Returns the StyleScheme currently used in buffer.

Returns:
  The StyleScheme set by set_style_scheme(), or empty Glib::RefPtr.

Glib::RefPtr<UndoManager> Gsv::Buffer::get_undo_manager | ( |  | ) |

Get the undo manager associated with the buffer.

Returns:
  A UndoManager.

Since gtksourceviewmm 2.10:

Glib::RefPtr<const UndoManager> Gsv::Buffer::get_undo_manager | ( |  | ) | const

Get the undo manager associated with the buffer.

Returns:
  A UndoManager.

Since gtksourceviewmm 2.10:

bool Gsv::Buffer::iter_backward_to_context_class_toggle | ( | Gtk::TextIter & | iter,
|  | const Glib::ustring & | context_class
| ) |  | const

Moves backward to the next toggle (on or off) of the context class.

If no matching context class toggles are found, returns `false`, otherwise `true`. Does not return toggles located at iter, only toggles after iter. Sets iter to the location of the toggle, or to the end of the buffer if no toggle is found.

Parameters:

  iter | A Gtk::TextIter.
  context_class | The context class.

Returns:
  Whether we found a context class toggle before iter.

Since gtksourceviewmm 2.10:

bool Gsv::Buffer::iter_forward_to_context_class_toggle | ( | Gtk::TextIter & | iter,
|  | const Glib::ustring & | context_class
| ) |  | const

Moves forward to the next toggle (on or off) of the context class.

If no matching context class toggles are found, returns `false`, otherwise `true`. Does not return toggles located at iter, only toggles after iter. Sets iter to the location of the toggle, or to the end of the buffer if no toggle is found.

Parameters:

  iter | A Gtk::TextIter.
  context_class | The context class.

Returns:
  Whether we found a context class toggle after iter.

Since gtksourceviewmm 2.10:

bool Gsv::Buffer::iter_has_context_class | ( | const Gtk::TextIter & | iter,
|  | const Glib::ustring & | context_class
| ) |  | const

Check if the class context_class is set on `iter`.

Parameters:

  iter | A Gtk::TextIter.
  context_class | Class to search for.

Returns:
  `true` if context_class is set on `iter`.

Since gtksourceviewmm 2.10:

Glib::PropertyProxy_ReadOnly<bool> Gsv::Buffer::property_can_redo | ( |  | ) | const

Whether Redo operation is possible.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gsv::Buffer::property_can_undo | ( |  | ) | const

Whether Undo operation is possible.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gsv::Buffer::property_highlight_matching_brackets | ( |  | ) |

Whether to highlight matching brackets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gsv::Buffer::property_highlight_matching_brackets | ( |  | ) | const

Whether to highlight matching brackets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gsv::Buffer::property_highlight_syntax | ( |  | ) |

Whether to highlight syntax in the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gsv::Buffer::property_highlight_syntax | ( |  | ) | const

Whether to highlight syntax in the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<Language> > Gsv::Buffer::property_language | ( |  | ) |

Language object to get highlighting patterns from.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Language> > Gsv::Buffer::property_language | ( |  | ) | const

Language object to get highlighting patterns from.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gsv::Buffer::property_max_undo_levels | ( |  | ) |

Number of undo levels for the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gsv::Buffer::property_max_undo_levels | ( |  | ) | const

Number of undo levels for the buffer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<StyleScheme> > Gsv::Buffer::property_style_scheme | ( |  | ) |

Style scheme.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<StyleScheme> > Gsv::Buffer::property_style_scheme | ( |  | ) | const

Style scheme.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<UndoManager> > Gsv::Buffer::property_undo_manager | ( |  | ) |

The buffer undo manager.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<UndoManager> > Gsv::Buffer::property_undo_manager | ( |  | ) | const

The buffer undo manager.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gsv::Buffer::redo | ( |  | ) |

Redoes the last undo operation.

Use can_redo() to check whether a call to this function will have any effect.

void Gsv::Buffer::remove_source_marks | ( | const Gtk::TextIter & | start,
|  | const Gtk::TextIter & | end,
|  | const Glib::ustring & | category
| ) |  |

Remove all marks of category between start and end from the buffer.

Parameters:

  start | A Gtk::TextIter.
  end | A Gtk::TextIter.
  category | Category to search for.

void Gsv::Buffer::remove_source_marks | ( | const Gtk::TextIter & | start,
|  | const Gtk::TextIter & | end
| ) |  |

Remove all marks of any category between start and end from the buffer.

Parameters:

  start | A Gtk::TextIter.
  end | A Gtk::TextIter.

Since gtksourceviewmm 2.10:

void Gsv::Buffer::set_default_undo_manager | ( |  | ) |

Set the default buffer undo manager.

Since gtksourceviewmm 2.10:

void Gsv::Buffer::set_highlight_matching_brackets | ( | bool | highlight = `true` | ) |

Controls the bracket match highlighting function in the buffer.

If activated, when you position your cursor over a bracket character (a parenthesis, a square bracket, etc.) the matching opening or closing bracket character will be highlighted. You can specify the style with the gtk_source_buffer_set_bracket_match_style() function.

Parameters:

  highlight | `true` if you want matching brackets highlighted.

void Gsv::Buffer::set_highlight_syntax | ( | bool | highlight = `true` | ) |

Controls whether syntax is highlighted in the buffer.

If highlight is `true`, the text will be highlighted according to the syntax patterns specified in the language set with set_language(). If highlight is `false`, syntax highlighting is disabled and all the Gtk::TextTag objects that have been added by the syntax highlighting engine are removed from the buffer.

Parameters:

  highlight | `true` to enable syntax highlighting, `false` to disable it.

void Gsv::Buffer::set_language | ( | const Glib::RefPtr< Language >& | language | ) |

Associate a Language with the source buffer.

If language is not empty and syntax highlighting is enabled, the syntax patterns defined in language will be used to highlight the text contained in the buffer. If language is empty, the text contained in the buffer is not highlighted.

The buffer holds a reference to language.

Parameters:

  language | A Language to set, or empty Glib::RefPtr.

void Gsv::Buffer::set_max_undo_levels | ( | int | max_undo_levels | ) |

Sets the number of undo levels for user actions the buffer will track.

If the number of user actions exceeds the limit set by this function, older actions will be discarded.

If max_undo_levels is -1, no limit is set.

A new action is started whenever the method Gtk::TextBuffer::begin_user_action() is called. In general, this happens whenever the user presses any key which modifies the buffer, but the undo manager will try to merge similar consecutive actions, such as multiple character insertions into one action. But, inserting a newline does start a new action.

Parameters:

  max_undo_levels | The desired maximum number of undo levels.

void Gsv::Buffer::set_style_scheme | ( | const Glib::RefPtr< StyleScheme >& | scheme | ) |

Sets style scheme used by the buffer.

If scheme is empty no style scheme is used.

Parameters:

  scheme | Style scheme.

void Gsv::Buffer::set_undo_manager | ( | const Glib::RefPtr< const UndoManager >& | undo_manager | ) |

Set the buffer undo manager.

Parameters:

  undo_manager | A UndoManager.

Since gtksourceviewmm 2.10:

Glib::SignalProxy2< void,Gtk::TextIter&,BracketMatchType > Gsv::Buffer::signal_bracket_matched | ( |  | ) |

Sets iter to a valid iterator pointing to the matching bracket if state is BracketMatchType::BRACKET_MATCH_FOUND.

Handler parameters:
  iter Iterator to initialize. state State of bracket matching.

Since gtksourceviewmm 3.0:

Prototype:
  `void on_my_bracket_matched(Gtk::TextIter& iter, BracketMatchType state)`

Glib::SignalProxy2< void,Gtk::TextIter&,Gtk::TextIter& > Gsv::Buffer::signal_highlight_updated | ( |  | ) |

Emitted whenever the syntax highlighting information has been updated, so that views can request a redraw if the region changed is visible.

Usually only view widgets displaying this buffer will be interested in this signal.

Handler parameters:
  start An iterator at the start of the updated region. end An iterator at the end of the updated region.

Prototype:
  `void on_my_highlight_updated(Gtk::TextIter& start, Gtk::TextIter& end)`

Glib::SignalProxy0< void > Gsv::Buffer::signal_redo | ( |  | ) |

Emitted whenever redo is requested.

In fact, it is emitted when redo() is called.

Since gtksourceviewmm 2.10:

Prototype:
  `void on_my_redo()`

Glib::SignalProxy1< void,const Glib::RefPtr<Gtk::TextMark>& > Gsv::Buffer::signal_source_mark_updated | ( |  | ) |

Emitted whenever a marker of sourcebuffer has changed and needs to be redisplayed by the view.

A change in a marker's type or location can trigger this signal. Note that moving a marker causes the emission of this signal twice: one for the old location and one for the new.

Handler parameters:
  where An iterator at the location where the change occurred.

Prototype:
  `void on_my_source_mark_updated(const Glib::RefPtr<Gtk::TextMark>& where)`

Glib::SignalProxy0< void > Gsv::Buffer::signal_undo | ( |  | ) |

Emitted whenever undo is requested.

In fact, it is emitted when undo() is called.

Since gtksourceviewmm 2.10:

Prototype:
  `void on_my_undo()`

void Gsv::Buffer::undo | ( |  | ) |

Undoes the last user action which modified the buffer.

Use can_undo() to check whether a call to this function will have any effect.

Actions are defined as groups of operations between a call to Gtk::TextBuffer::begin_user_action() and Gtk::TextBuffer::end_user_action(), or sequences of similar edits (inserts or deletes) on the same line.

void Gsv::Buffer::unset_style_scheme | ( |  | ) |

Unsets style scheme used by the buffer.

It is the same like calling set_style_scheme() with empty pointer.

## Friends And Related Function Documentation

Glib::RefPtr< Gsv::Buffer > wrap | ( | GtkSourceBuffer * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.